---
apiVersion: rbac.authorization.k8s.io/v1
kind: RoleBinding
metadata:
  name: default_view
roleRef:
  kind: ClusterRole
  apiGroup: rbac.authorization.k8s.io
  name: view
subjects:
  - kind: ServiceAccount
    name: default
---
apiVersion: v1
kind: ConfigMap
metadata:
  labels:
    app: rest-fights
    application: fights-service
    system: quarkus-super-heroes
  name: rest-fights-config
data:
  quarkus.liquibase-mongodb.migrate-at-start: "false"
  quarkus.mongodb.hosts: fights-db:27017
  quarkus.stork.hero-service.service-discovery.type: kubernetes
  quarkus.stork.hero-service.service-discovery.application: rest-heroes
  quarkus.stork.hero-service.service-discovery.refresh-period: 1M
  quarkus.stork.villain-service.service-discovery.type: kubernetes
  quarkus.stork.villain-service.service-discovery.application: rest-villains
  quarkus.stork.villain-service.service-discovery.refresh-period: 1M
  quarkus.opentelemetry.tracer.exporter.otlp.endpoint: http://otel-collector:4317
  kafka.bootstrap.servers: PLAINTEXT://fights-kafka:9092
  mp.messaging.connector.smallrye-kafka.apicurio.registry.url: http://apicurio:8080/apis/registry/v2
---
apiVersion: v1
kind: Secret
metadata:
  labels:
    app: rest-fights
    application: fights-service
    system: quarkus-super-heroes
  name: rest-fights-config-creds
data:
  quarkus.mongodb.credentials.username: c3VwZXJmaWdodA==
  quarkus.mongodb.credentials.password: c3VwZXJmaWdodA==
type: Opaque
---
apiVersion: v1
kind: Secret
metadata:
  labels:
    app: fights-db
    application: fights-service
    system: quarkus-super-heroes
  name: fights-db-config
data:
  MONGODB_DATABASE: ZmlnaHRz
  MONGODB_USERNAME: c3VwZXJmaWdodA==
  MONGODB_PASSWORD: c3VwZXJmaWdodA==
  MONGODB_ROOT_USER: c3VwZXI=
  MONGODB_ROOT_PASSWORD: c3VwZXI=
type: Opaque
---
apiVersion: apps/v1
kind: Deployment
metadata:
  labels:
    app: fights-db
    application: fights-service
    system: quarkus-super-heroes
    app.kubernetes.io/part-of: fights-service
    app.openshift.io/runtime: mongodb
  name: fights-db
spec:
  replicas: 1
  selector:
    matchLabels:
      name: fights-db
  template:
    metadata:
      labels:
        application: fights-service
        name: fights-db
        system: quarkus-super-heroes
    spec:
      containers:
        - envFrom:
            - secretRef:
                name: fights-db-config
          image: bitnami/mongodb:5.0
          name: fights-db
          ports:
            - containerPort: 27017
          resources:
            limits:
              memory: 256Mi
            requests:
              memory: 64Mi
---
apiVersion: v1
kind: Service
metadata:
  labels:
    name: fights-db
    application: fights-service
    system: quarkus-super-heroes
  name: fights-db
spec:
  ports:
    - port: 27017
      protocol: TCP
      targetPort: 27017
  selector:
    name: fights-db
  type: ClusterIP
---
apiVersion: apps/v1
kind: Deployment
metadata:
  labels:
    app: fights-kafka
    application: fights-service
    system: quarkus-super-heroes
    app.kubernetes.io/part-of: fights-service
    app.openshift.io/runtime: amq
  name: fights-kafka
spec:
  replicas: 1
  selector:
    matchLabels:
      name: fights-kafka
  template:
    metadata:
      labels:
        application: fights-service
        name: fights-kafka
        system: quarkus-super-heroes
    spec:
      containers:
        - command:
            - sh
            - -c
            - "export CLUSTER_ID=$(bin/kafka-storage.sh random-uuid) && bin/kafka-storage.sh\
              \ format -t ${CLUSTER_ID} -c config/kraft/server.properties && bin/kafka-server-start.sh\
              \ config/kraft/server.properties --override advertised.listeners=${KAFKA_ADVERTISED_LISTENERS}"
          env:
            - name: LOG_DIR
              value: /tmp/logs
            - name: KAFKA_ADVERTISED_LISTENERS
              value: PLAINTEXT://fights-kafka:9092
          image: quay.io/strimzi/kafka:0.28.0-kafka-3.1.0
          name: fights-kafka
          ports:
            - containerPort: 9092
          resources:
            limits:
              memory: 768Mi
            requests:
              memory: 128Mi
---
apiVersion: v1
kind: Service
metadata:
  labels:
    name: fights-kafka
    application: fights-service
    system: quarkus-super-heroes
  name: fights-kafka
spec:
  ports:
    - port: 9092
      protocol: TCP
      targetPort: 9092
  selector:
    name: fights-kafka
  type: ClusterIP
---
apiVersion: apps/v1
kind: Deployment
metadata:
  annotations:
    prometheus.io/scrape: "true"
    prometheus.io/path: /metrics
    prometheus.io/port: "8080"
    prometheus.io/scheme: http
  labels:
    app: apicurio
    application: fights-service
    system: quarkus-super-heroes
    app.kubernetes.io/part-of: fights-service
    app.kubernetes.io/name: apicurio
    app.kubernetes.io/version: 2.2.3.Final
    app.openshift.io/runtime: apicurio
  name: apicurio
spec:
  replicas: 1
  selector:
    matchLabels:
      name: apicurio
  template:
    metadata:
      annotations:
        prometheus.io/scrape: "true"
        prometheus.io/path: /metrics
        prometheus.io/port: "8080"
        prometheus.io/scheme: http
      labels:
        application: fights-service
        name: apicurio
        system: quarkus-super-heroes
    spec:
      containers:
        - env:
            - name: REGISTRY_AUTH_ANONYMOUS_READ_ACCESS_ENABLED
              value: "true"
          image: quay.io/apicurio/apicurio-registry-mem:2.2.3.Final
          livenessProbe:
            failureThreshold: 3
            httpGet:
              path: /health/live
              port: 8080
              scheme: HTTP
            initialDelaySeconds: 0
            periodSeconds: 30
            successThreshold: 1
            timeoutSeconds: 10
          name: apicurio
          ports:
            - containerPort: 8080
              name: http
              protocol: TCP
          readinessProbe:
            failureThreshold: 3
            httpGet:
              path: /health/ready
              port: 8080
              scheme: HTTP
            initialDelaySeconds: 0
            periodSeconds: 30
            successThreshold: 1
            timeoutSeconds: 10
          resources:
            limits:
              memory: 768Mi
            requests:
              memory: 128Mi
---
apiVersion: v1
kind: Service
metadata:
  annotations:
    prometheus.io/scrape: "true"
    prometheus.io/path: /metrics
    prometheus.io/port: "8080"
    prometheus.io/scheme: http
  labels:
    name: apicurio
    application: fights-service
    system: quarkus-super-heroes
  name: apicurio
spec:
  ports:
    - port: 8080
      protocol: TCP
      targetPort: 8080
  selector:
    name: apicurio
  type: ClusterIP
---
apiVersion: route.openshift.io/v1
kind: Route
metadata:
  annotations:
    prometheus.io/scrape: "true"
    prometheus.io/path: /metrics
    prometheus.io/port: "8080"
    prometheus.io/scheme: http
  labels:
    app: apicurio
    application: fights-service
    system: quarkus-super-heroes
    app.openshift.io/runtime: apicurio
  name: apicurio
spec:
  port:
    targetPort: 8080
  to:
    kind: Service
    name: apicurio
---
apiVersion: image.openshift.io/v1
kind: ImageStream
metadata:
  annotations:
    app.openshift.io/vcs-url: https://github.com/quarkusio/quarkus-super-heroes
    app.openshift.io/connects-to: "fights-db,fights-kafka,apicurio,rest-villains,rest-heroes,otel-collector"
    app.openshift.io/vcs-ref: main
    app.quarkus.io/build-timestamp: 2022-11-14 - 19:52:10 +0000
  labels:
    app: rest-fights
    application: fights-service
    system: quarkus-super-heroes
    app.openshift.io/runtime: quarkus
    app.kubernetes.io/version: java17-latest
    app.kubernetes.io/part-of: fights-service
    app.kubernetes.io/name: rest-fights
  name: rest-fights
spec:
  lookupPolicy:
    local: false
  tags:
    - from:
        kind: DockerImage
        name: quay.io/quarkus-super-heroes/rest-fights:java11-latest
      importPolicy: {}
      name: java11-latest
      referencePolicy:
        type: Source
    - from:
        kind: DockerImage
        name: quay.io/quarkus-super-heroes/rest-fights:java17-latest
      importPolicy: {}
      name: java17-latest
      referencePolicy:
        type: Source
    - from:
        kind: DockerImage
        name: quay.io/quarkus-super-heroes/rest-fights:native-latest
      importPolicy: {}
      name: native-latest
      referencePolicy:
        type: Source
---
apiVersion: apps.openshift.io/v1
kind: DeploymentConfig
metadata:
  annotations:
    app.openshift.io/vcs-url: https://github.com/quarkusio/quarkus-super-heroes
    app.openshift.io/connects-to: "fights-db,fights-kafka,apicurio,rest-villains,rest-heroes,otel-collector"
    app.openshift.io/vcs-ref: main
    app.quarkus.io/build-timestamp: 2022-11-14 - 19:52:10 +0000
    prometheus.io/scrape: "true"
    prometheus.io/path: /q/metrics
    prometheus.io/port: "8082"
    prometheus.io/scheme: http
  labels:
    app.kubernetes.io/name: rest-fights
    app.kubernetes.io/part-of: fights-service
    app.kubernetes.io/version: java17-latest
    app: rest-fights
    application: fights-service
    system: quarkus-super-heroes
    app.openshift.io/runtime: quarkus
  name: rest-fights
spec:
  replicas: 1
  selector:
    app.kubernetes.io/version: java17-latest
    app.kubernetes.io/part-of: fights-service
    app.kubernetes.io/name: rest-fights
  template:
    metadata:
      annotations:
        app.openshift.io/vcs-url: https://github.com/quarkusio/quarkus-super-heroes
        app.openshift.io/connects-to: "fights-db,fights-kafka,apicurio,rest-villains,rest-heroes,otel-collector"
        app.openshift.io/vcs-ref: main
        app.quarkus.io/build-timestamp: 2022-11-14 - 19:52:10 +0000
        prometheus.io/scrape: "true"
        prometheus.io/path: /q/metrics
        prometheus.io/port: "8082"
        prometheus.io/scheme: http
      labels:
        app: rest-fights
        application: fights-service
        system: quarkus-super-heroes
        app.openshift.io/runtime: quarkus
        app.kubernetes.io/version: java17-latest
        app.kubernetes.io/part-of: fights-service
        app.kubernetes.io/name: rest-fights
    spec:
      containers:
        - env:
            - name: KUBERNETES_NAMESPACE
              valueFrom:
                fieldRef:
                  fieldPath: metadata.namespace
          envFrom:
            - secretRef:
                name: rest-fights-config-creds
            - configMapRef:
                name: rest-fights-config
          image: rest-fights:java17-latest
          imagePullPolicy: Always
          livenessProbe:
            failureThreshold: 3
            httpGet:
              path: /q/health/live
              port: 8082
              scheme: HTTP
            initialDelaySeconds: 0
            periodSeconds: 30
            successThreshold: 1
            timeoutSeconds: 10
          name: rest-fights
          ports:
            - containerPort: 8082
              name: http
              protocol: TCP
          readinessProbe:
            failureThreshold: 3
            httpGet:
              path: /q/health/ready
              port: 8082
              scheme: HTTP
            initialDelaySeconds: 0
            periodSeconds: 30
            successThreshold: 1
            timeoutSeconds: 10
          resources:
            limits:
              memory: 768Mi
            requests:
              memory: 256Mi
  triggers:
    - imageChangeParams:
        automatic: true
        containerNames:
          - rest-fights
        from:
          kind: ImageStreamTag
          name: rest-fights:java17-latest
      type: ImageChange
---
apiVersion: v1
kind: Service
metadata:
  annotations:
    app.openshift.io/vcs-url: https://github.com/quarkusio/quarkus-super-heroes
    app.openshift.io/connects-to: "fights-db,fights-kafka,apicurio,rest-villains,rest-heroes,otel-collector"
    app.openshift.io/vcs-ref: main
    app.quarkus.io/build-timestamp: 2022-11-14 - 19:52:10 +0000
    prometheus.io/scrape: "true"
    prometheus.io/path: /q/metrics
    prometheus.io/port: "8082"
    prometheus.io/scheme: http
  labels:
    app.kubernetes.io/name: rest-fights
    app.kubernetes.io/part-of: fights-service
    app.kubernetes.io/version: java17-latest
    app: rest-fights
    application: fights-service
    system: quarkus-super-heroes
    app.openshift.io/runtime: quarkus
  name: rest-fights
spec:
  ports:
    - name: http
      port: 80
      protocol: TCP
      targetPort: 8082
  selector:
    app.kubernetes.io/name: rest-fights
    app.kubernetes.io/part-of: fights-service
    app.kubernetes.io/version: java17-latest
  type: ClusterIP
---
apiVersion: route.openshift.io/v1
kind: Route
metadata:
  annotations:
    app.openshift.io/vcs-url: https://github.com/quarkusio/quarkus-super-heroes
    app.openshift.io/connects-to: "fights-db,fights-kafka,apicurio,rest-villains,rest-heroes,otel-collector"
    app.openshift.io/vcs-ref: main
    app.quarkus.io/build-timestamp: 2022-11-14 - 19:52:10 +0000
  labels:
    app.kubernetes.io/name: rest-fights
    app.kubernetes.io/part-of: fights-service
    app.kubernetes.io/version: java17-latest
    app: rest-fights
    application: fights-service
    system: quarkus-super-heroes
    app.openshift.io/runtime: quarkus
  name: rest-fights
spec:
  host: ""
  port:
    targetPort: http
  to:
    kind: Service
    name: rest-fights
